#Script for the msABC simulations... there will be 14 of these total
#base
#ind10, ind20, ind50, ind100
#block200, block500, block2k, block5k, block10k
#size200, size1k, size2k, size5k


#############################
#Things to change are up here...
#############################

title = "size200";


samplen = 2;
blockn = 1000;
bsize = 0.1;



nreps = 200000;



#############################
#First draw the priors for the analysis
#############################

modindex = c(rep(1,nreps), rep(2,nreps), rep(3,nreps), rep(4,nreps), rep(5,nreps), rep(6,nreps), rep(7, nreps));
totreps = length(modindex);
Theta = runif(totreps, 0.028, 1.4);
Theta = Theta*bsize;
Nm = rexp(totreps, 0.1);

Tgf = runif(totreps, 0.1, 0.5);
T1 = c();
for(j in 1:totreps) {
	T1[j] = runif(1, max(Tgf[j], 0.4), 1);
}
T2 = runif(totreps, 1, 4);
Tdur = runif(totreps, 0.01,0.1);

priors = data.frame(modindex, Theta, Nm, Tgf, T1, T2, Tdur);
write.csv(priors,paste("priorvals-",title,".csv", sep = ""));



#############################
#Next come the msABC simulations
#############################


library(psych);

nind = samplen*3;
nloci = blockn;
npops = 3;
L = bsize*2000;

outnames = c("model","nind", "nloci","length","iter","mean.sites","var.sites","skew.sites", "kurt.sites", "mean.sites1", "var.sites1", "skew.sites1", "kurt.sites1", "mean.sites2", "var.sites2", "skew.sites2", "kurt.sites2", "mean.sites3", "var.sites3", "skew.sites3", "kurt.sites3", "mean.shared12", "var.shared12", "skew.shared12", "kurt.shared12", "mean.shared13","var.shared13", "skew.shared13", "kurt.shared13", "mean.shared23","var.shared23", "skew.shared23", "kurt.shared23", "mean.fixed12","var.fixed12", "skew.fixed12", "kurt.fixed12", "mean.fixed13", "var.fixed13", "skew.fixed13", "kurt.fixed13", "mean.fixed23","var.fixed23", "skew.fixed23", "kurt.fixed23", "mean.priv12","var.priv12", "skew.priv12", "kurt.priv12", "mean.priv13","var.priv13", "skew.priv13", "kurt.priv13", "mean.priv23","var.priv23", "skew.priv23", "kurt.priv23");

write(outnames, paste("sumstatsCV-",title,".csv", sep = ""), sep = ",", ncolumns = length(outnames));

prior = read.csv(paste("priorvals-",title,".csv", sep = ""), header = TRUE);
myout = matrix(data = NA, nrow = totreps, ncol = length(outnames));

for(iter in 1:totreps) {

	
#Parameters drawn from a distribution
#Eventually we will replace these with keepers$Theta[i], etc
	theta = prior$Theta[iter];
	mig = prior$Nm[iter];
	migtime = prior$Tgf[iter];
	splittime23 = prior$T1[iter];
	splittime12 = prior$T2[iter];
	modelindex = prior$modindex[iter];
	migdur = prior$Tdur[iter];

#Scripts for simulating the different models
#TURN THESE ON AND OFF TO CHOOSE THE APPROPRIATE MODEL FOR THE SCRIPT!!
	if(modelindex == 1) {
		model = "A";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -em 1 1 2 90 -em 1.05 1 2 0.0 -ej 1.5 3 2 -ej 4 2 1 --options options.txt --verbose >dataA"
		msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-em", migtime, "1 2", mig, "-em", migtime+migdur, "1 2 0.0", "-ej", splittime23, "3 2 -ej", splittime12,"2 1 --options options.txt --verbose >",paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
	} else if(modelindex == 2) {
		model = "B";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -em 1 1 3 90 -em 1.05 1 2 0.0 -ej 1.5 3 2 -ej 4 2 1 --options options.txt --verbose >dataB"
		msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-em", migtime, "1 3", mig, "-em", migtime+migdur, "1 2 0.0", "-ej", splittime23, "3 2 -ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
	} else if(modelindex == 3) {
		model = "C";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -ej 1.5 3 2 -em 1.5 1 2 90 -ej 4 2 1 --options options.txt --verbose >dataC"
        msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-ej", splittime23, "3 2 -em", splittime23, "1 2", mig, "-ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
    } else if(modelindex == 4) {
		model = "D";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -em 1 2 1 90 -em 1.05 2 1 0.0 -ej 1.5 3 2 -ej 4 2 1 --options options.txt --verbose >dataD"
		msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-em", migtime, "2 1", mig, "-em", migtime+migdur, "2 1 0.0", "-ej", splittime23, "3 2 -ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
	} else if(modelindex == 5) {
		model = "E";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -em 1 3 1 90 -em 1.05 3 1 0.0 -ej 1.5 3 2 -ej 4 2 1 --options options.txt --verbose >dataE"
		msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-em", migtime, "3 1", mig, "-em", migtime+migdur, "3 1 0.0", "-ej", splittime23, "3 2 -ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
	} else if(modelindex == 6) {
		model = "F";
		#msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -ej 1.5 3 2 -em 1.5 2 1 90 -ej 4 2 1 --options options.txt --verbose >dataF"
		msline = paste("msABC", nind, nloci,"-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-ej", splittime23, "3 2 -em", splittime23, "2 1", mig, "-ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter, sep = ""), sep = " ");
	} else if(modelindex == 7) {
        model = "ISO";
        #msline = "msABC 6 2231 -t 0.7 -I 3 2 2 2 0.0 -ej 1.5 3 2 -ej 4 2 1 --options options.txt --verbose >dataISO"
        msline = paste("msABC", nind, nloci, "-t", theta, "-I 3", nind/npops, nind/npops, nind/npops, "0.0", "-ej", splittime23, "3 2 -ej", splittime12, "2 1 --options options.txt --verbose >", paste("sim",model,"-",title,"-",iter,sep=""), sep = " ");
    }
	
	system(msline);
	sim = read.table(paste("sim",model,"-",title,"-",iter,sep=""), header = TRUE);

	#Down here you calculate and report the statistics for each step in the set of simulations...

	myout[iter,] = c(model, nind, nloci, L, iter, mean(sim$s_segs), var(sim$s_segs), skew(sim$s_segs), kurtosi(sim$s_segs), mean(sim$s_segs_1), var(sim$s_segs_1), skew(sim$s_segs_1), kurtosi(sim$s_segs_1), mean(sim$s_segs_2), var(sim$s_segs_2), skew(sim$s_segs_2), kurtosi(sim$s_segs_2), mean(sim$s_segs_3), var(sim$s_segs_3), skew(sim$s_segs_3), kurtosi(sim$s_segs_3), mean(sim$s_perc_shared_1_2, na.rm = TRUE), var(sim$s_perc_shared_1_2, na.rm = TRUE), skew(sim$s_perc_shared_1_2, na.rm = TRUE), kurtosi(sim$s_perc_shared_1_2, na.rm = TRUE),mean(sim$s_perc_shared_1_3, na.rm = TRUE), var(sim$s_perc_shared_1_3, na.rm = TRUE),  skew(sim$s_perc_shared_1_3, na.rm = TRUE), kurtosi(sim$s_perc_shared_1_3, na.rm = TRUE),mean(sim$s_perc_shared_2_3, na.rm = TRUE), var(sim$s_perc_shared_2_3, na.rm = TRUE),  skew(sim$s_perc_shared_2_3, na.rm = TRUE), kurtosi(sim$s_perc_shared_2_3, na.rm = TRUE), mean(sim$s_perc_fixed_dif_1_2, na.rm = TRUE), var(sim$s_perc_fixed_dif_1_2, na.rm = TRUE), skew(sim$s_perc_fixed_dif_1_2, na.rm = TRUE), kurtosi(sim$s_perc_fixed_dif_1_2, na.rm = TRUE), mean(sim$s_perc_fixed_dif_1_3, na.rm = TRUE), var(sim$s_perc_fixed_dif_1_3, na.rm = TRUE),  skew(sim$s_perc_fixed_dif_1_3, na.rm = TRUE), kurtosi(sim$s_perc_fixed_dif_1_3, na.rm = TRUE), mean(sim$s_perc_fixed_dif_2_3, na.rm = TRUE), var(sim$s_perc_fixed_dif_2_3, na.rm = TRUE),  skew(sim$s_perc_fixed_dif_2_3, na.rm = TRUE), kurtosi(sim$s_perc_fixed_dif_2_3, na.rm = TRUE), mean(sim$s_perc_private_1_2, na.rm = TRUE), var(sim$s_perc_private_1_2, na.rm = TRUE), skew(sim$s_perc_private_1_2, na.rm = TRUE), kurtosi(sim$s_perc_private_1_2, na.rm = TRUE), mean(sim$s_perc_private_1_3, na.rm = TRUE), var(sim$s_perc_private_1_3, na.rm = TRUE), skew(sim$s_perc_private_1_3, na.rm = TRUE), kurtosi(sim$s_perc_private_1_3, na.rm = TRUE), mean(sim$s_perc_private_2_3, na.rm = TRUE), var(sim$s_perc_private_2_3, na.rm = TRUE), skew(sim$s_perc_private_2_3, na.rm = TRUE), kurtosi(sim$s_perc_private_2_3, na.rm = TRUE));
    
    print(iter);

	system(paste("rm",paste("sim",model,"-",title,"-",iter,sep=""), sep = " ")); 

	write(myout[iter,], paste("sumstatsCV-",title,".csv", sep = ""), append = TRUE, ncolumns = length(outnames), sep = ",");

}



system("rm seedms log.txt");

